<cfcomponent output="yes">

    <cffunction name="getAllData" access="remote">
        
        <cfset var qAllData="">
        
        <cfquery name="qAllData" datasource="F4CF_FictitiousSalesPlanner">
        	SELECT * FROM SalesTargets
        </cfquery>
        
        <cfreturn qAllData>
        
    </cffunction>
    
    <cffunction name="getItem" output="false" access="remote" returntype="any">
    
    	<cfargument name="SALESTARGETID" required="true" />     
        
        <cfset var qItem="">
            
        <cfquery name="qItem" datasource="F4CF_FictitiousSalesPlanner">
        	SELECT * FROM SalesTargets 
            WHERE SALESTARGETID = <CFQUERYPARAM CFSQLTYPE="CF_SQL_INTEGER" VALUE="#ARGUMENTS.SALESTARGETID#">
        </cfquery>
    
        <cfreturn qItem>
             
    </cffunction>
    
        <cffunction name="createItem" output="false" access="remote" returntype="any">
            
        <cfargument name="item" required="true" />
                  
		<cfquery name="createItem" datasource="F4CF_FictitiousSalesPlanner" result="result">
                INSERT INTO SalesTargets (SALESTARGETID, FIRSTNAME, LASTNAME, EMAIL, PHONE, YTD, Q1GOAL, EMPIMAGE, REGION ) 
                    VALUES (<CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.SALESTARGETID#">,
                            <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.FIRSTNAME#">,
                            <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.LASTNAME#">,
                            <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.EMAIL#">,
                            <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.PHONE#">,
                            <CFQUERYPARAM cfsqltype="CF_SQL_INTEGER" VALUE="#item.YTD#">,
                            <CFQUERYPARAM cfsqltype="CF_SQL_INTEGER" VALUE="#item.Q1GOAL#">,
                            <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.EMPIMAGE#">,
                            <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.REGION#">)
        </cfquery>
            
    </cffunction>
    
    <cffunction name="updateItem" access="remote">
        
        <cfargument name="item" required="true">
                
        <cfquery name="qupdateItem" datasource="F4CF_FictitiousSalesPlanner"> 
        	UPDATE SalesTargets 
            	SET FIRSTNAME = <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.FIRSTNAME#">,
                    LASTNAME = <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.LASTNAME#">,
                    PHONE = <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.PHONE#">, 
                    EMAIL = <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.EMAIL#">,
                    YTD = <CFQUERYPARAM cfsqltype="CF_SQL_INTEGER" VALUE="#item.YTD#">,
                    Q1GOAL = <CFQUERYPARAM cfsqltype="CF_SQL_INTEGER" VALUE="#item.Q1GOAL#">,
                    EMPIMAGE = <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.EMPIMAGE#">,
                    REGION = <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.REGION#">
            	WHERE SALESTARGETID = <CFQUERYPARAM cfsqltype="CF_SQL_VARCHAR" VALUE="#item.SALESTARGETID#">
    	</cfquery>
    
    </cffunction>
    
    <cffunction name="deleteItem" output="false" access="remote" returntype="void">
    	
        <cfargument name="SALESTARGETID" type="string" required="true" />
    
    	<cfquery name="delete" datasource="F4CF_FictitiousSalesPlanner">
        	DELETE FROM SalesTargets
        	WHERE SALESTARGETID = <CFQUERYPARAM CFSQLTYPE="CF_SQL_VARCHAR" VALUE="#ARGUMENTS.SALESTARGETID#">
        </cfquery>
                  
    </cffunction>
    
    <cffunction name="getEmployeeDataByRegion" access="remote">
    
        <cfargument name="region" type="string"/>
           
        <cfquery datasource="F4CF_FictitiousSalesPlanner" name = "GetAllData">
               SELECT FirstName, LastName, Email, Phone, Q1Goal, YTD
   			   FROM SalesTargets
               WHERE Region = '#arguments.region#'
        </cfquery>
            
        <cfreturn GetAllData>
    
    </cffunction>
    
</cfcomponent>